=== debian/changelog ===
fastcdr (1.1.0-1.2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:57:18 +0000

fastcdr (1.1.0-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Amend 64-bit time_t transition; symbols file said libfastcdr1 still

 -- Julian Andres Klode <jak@debian.org>  Sat, 23 Mar 2024 20:34:54 +0100

fastcdr (1.1.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062546

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 03:46:59 +0000

fastcdr (1.1.0-1) unstable; urgency=medium

  * New upstream version 1.1.0
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Wed, 14 Jun 2023 15:01:29 +0200
