=== debian/changelog ===
fastcdr (2.2.2-1) unstable; urgency=medium

  * New upstream version 2.2.2
  * Refresh patch (no functional change)

 -- Timo Röhling <roehling@debian.org>  Thu, 27 Jun 2024 13:26:02 +0200

fastcdr (2.2.1-3) unstable; urgency=medium

  * Upload to unstable.
  * Drop .0 patch version from .symbols

 -- Timo Röhling <roehling@debian.org>  Wed, 17 Apr 2024 22:34:04 +0200

fastcdr (2.2.1-2) experimental; urgency=medium

  * Re-enable test suite
  * Fix autopkgtest

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Apr 2024 10:35:00 +0200

fastcdr (2.2.1-1) experimental; urgency=medium

  * New upstream version 2.2.1
  * Refresh patches (no functional changes)
  * Bump SONAME to 2
  * Bump Standards-Version to 4.7.0
  * Reformat d/control
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Mon, 15 Apr 2024 16:26:26 +0200
