## fastcdr 2.2.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 ###############################################################################
 # Project                                                                     #
 ###############################################################################
-project(fastcdr VERSION 2.2.2 LANGUAGES CXX)
+project(fastcdr VERSION 2.2.5 LANGUAGES CXX)
 
 set(PROJECT_NAME_STYLED "FastCDR")
 set(PROJECT_NAME_LARGE "Fast CDR")
