=== debian/changelog ===
fastcdr (2.2.5-1) unstable; urgency=medium

  * Update d/watch to latest GitHub recipe
  * New upstream version 2.2.5
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Mon, 14 Oct 2024 20:07:16 +0200

fastcdr (2.2.4-1) unstable; urgency=medium

  * New upstream version 2.2.4
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 10 Sep 2024 13:37:21 +0200

fastcdr (2.2.3-1) unstable; urgency=medium

  * New upstream version 2.2.3
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Aug 2024 11:42:27 +0200
