=== debian/tests/control ===
Tests: run-test-suite
Depends:
 cmake,
 g++ | c++-compiler,
 libfastcdr-dev,
 libgtest-dev,
Restrictions: allow-stderr
